﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraTransition : MonoBehaviour {

	public Transform[] views;
	public float transitionSpeed;
	Transform currentView;
	Vector3 currentAngle;

	// Use this for initialization
	void Start () {

		currentView = views[0];
		transform.position = currentView.position;
//		currentAngle = currentView.transform.rotation.eulerAngles;
		transform.eulerAngles = currentView.transform.rotation.eulerAngles;

	}

	// Update is called once per frame
	void Update () {
		
		if (Input.GetKey (KeyCode.Space)) {
			currentView = views[1];
		}
		else {
			currentView = views[0];
		}

	}

	
	void LateUpdate () {

		transform.position = Vector3.Lerp(transform.position, currentView.position, Time.deltaTime * transitionSpeed);

		 currentAngle = new Vector3 (
			Mathf.LerpAngle(transform.rotation.eulerAngles.x, currentView.transform.rotation.eulerAngles.x, Time.deltaTime * transitionSpeed),
			Mathf.LerpAngle(transform.rotation.eulerAngles.y, currentView.transform.rotation.eulerAngles.y, Time.deltaTime * transitionSpeed),
			Mathf.LerpAngle(transform.rotation.eulerAngles.z, currentView.transform.rotation.eulerAngles.z, Time.deltaTime * transitionSpeed));

		transform.eulerAngles = currentAngle;

	}

}
