﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DeliveryZone : MonoBehaviour {

    private House House;
    public MissionsDisplayScript.MISSION_ITEMS Type;

    public GameObject Sound;
    private bool Visited = false;
    public GameObject CatSound;
    public GameObject DogSound;
    public GameObject RagingSound;

	// Use this for initialization
	void Start ()
    {
        GameObject parent = this.gameObject;
        
        for (int i = 0; i < 4; i++)
        {
            parent = parent.transform.parent.gameObject;
            if ( parent != null && parent.CompareTag("House") )
            {
                break;
            }
        }
        
        if (parent != null && parent.GetComponent<House>() != null)
        {
            House = parent.GetComponent<House>();
        }
        else
        {
            Debug.LogError("Ce truc ne possède pas de Component \"House\" : ", parent.transform);
        }
	}
	
	// Update is called once per frame
	void Update () {
		
	}

    void OnTriggerEnter(Collider collider)
    {
        if(collider.gameObject.CompareTag("Projectile"))
        {
            Debug.Log("Collision avec un projectile !");
            collider.GetComponent<BoxCollider>().isTrigger = true;
            if(!Visited && Type == MissionsDisplayScript.MISSION_ITEMS.DOOR || Type == MissionsDisplayScript.MISSION_ITEMS.WINDOW)
            {
                if(transform.childCount > 0)
                {
                    GetComponent<MeshRenderer>().enabled = false;
                    transform.GetChild(0).gameObject.SetActive(true);
                    Instantiate(Sound, transform.position, Quaternion.identity);
                }
            }
            else if (!Visited && Type == MissionsDisplayScript.MISSION_ITEMS.MAILBOX)
            {
                if (transform.childCount > 0)
                {
                    transform.GetChild(0).transform.eulerAngles = new Vector3(-20, 0, 0);
                    Instantiate(Sound, transform.position, transform.rotation);
                    Visited = true;
                }
            }
            else if (!Visited && Type == MissionsDisplayScript.MISSION_ITEMS.CHIMNEY)
            {
                if (transform.childCount > 0)
                {
                    transform.GetChild(0).gameObject.SetActive(true);
                }
            }


            // Other Random Sounds
            float r = UnityEngine.Random.Range(0f, 1f);
            if(r < 0.02f)
            {
                Instantiate(CatSound, transform.position, Quaternion.identity);
            }
            r = UnityEngine.Random.Range(0f, 1f);
            if (r < 0.01f)
            {
                Instantiate(DogSound, transform.position, Quaternion.identity);
            }
            r = UnityEngine.Random.Range(0f, 1f);
            if (r < 0.02f)
            {
                Instantiate(RagingSound, transform.position, Quaternion.identity);
            }


            Visited = true;


            Projectile projectile = collider.gameObject.GetComponent<Projectile>();
            if (projectile != null)
            {
                if (!projectile.IsDelivered())
                {
                    Debug.Log("Le projectile est un objet qui n'a pas encore été livré !");
                    if (projectile.DisplayName == "Lettre")
                    {
                        Debug.Log("Il s'agit d'une lettre!");
                        if (House != null && GameController.instance.Check(House.Number, Type, MissionsDisplayScript.MISSION_ITEMS.MAIL))
                        {
                            Debug.Log("Objectif accomplit !");
                            projectile.SetDelivered(true);
                        }
                    }
                    else // Il s'agit d'un Colis
                    {
                        Debug.Log("Il s'agit d'un colis!");
                        if (House != null && GameController.instance.Check(House.Number, Type, MissionsDisplayScript.MISSION_ITEMS.PACKAGE))
                        {
                            Debug.Log("Objectif accomplit !");
                            projectile.SetDelivered(true);
                        }
                    }
                }
            }
            else
            {
                Debug.LogError(collider.transform.name + " n'a pas de Component Projectile");
            }
        }
    }
}
