﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameController : MonoBehaviour {

    public MissionsDisplayScript MissionsController;
    public Turret Turret;
    public TimerScript Timer;

    public int Reward = 10;
    public int PackagesDeliveredCount = 0;
    public int LettersDeliveredCount = 0;

    public static GameController instance = null;              //Static instance of GameManager which allows it to be accessed by any other script.
    
    // Awake is always called before any Start functions
    void Awake()
    {
        // Check if instance already exists
        if (instance == null)
        {
            // If not, set instance to this
            instance = this;
        }   
        
        // If instance already exists and it's not this:
        else if (instance != this)
        {
            // Then destroy this. This enforces our singleton pattern, meaning there can only ever be one instance of a GameManager.
            Destroy(gameObject);
        }
    }

    public int GetPackagesThrowsCount()
    {
        return Turret.PackagesThrowsCount;
    }

    public int GetLettersThrowsCount()
    {
        return Turret.LettersThrowsCount;
    }

    public bool Check(int adresse, MissionsDisplayScript.MISSION_ITEMS target, MissionsDisplayScript.MISSION_ITEMS type)
    {
        if(MissionsController.Accomplish(adresse, target, type))
        {
            // Comptabilisation des paquets et lettres perdu(e)s
            if(type == MissionsDisplayScript.MISSION_ITEMS.MAIL)
            {
                LettersDeliveredCount += 1;
            }
            else if (type == MissionsDisplayScript.MISSION_ITEMS.PACKAGE)
            {
                PackagesDeliveredCount += 1;
            }

            // Si on a terminé la mission
            if(MissionsController.CurrentMissionIsCompleted())
            {
                MissionsController.NextMision();
                Timer.GainTime(Reward);
            }
            else
            {
                Debug.Log("J'update la vue");
                MissionsController.UpdateView();
            }
            return true;
        }
        return false;
    } 
}
