﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class MissionsDisplayScript : MonoBehaviour {
    public int CurrentMission;
    public int LastShown;
    public int columnCount = 0;

    public enum MISSION_ITEMS
    {
        CHIMNEY,
        DOOR,
        WINDOW,
        MAILBOX,
        MAIL,
        PACKAGE
    }

    public int[,] Missions;

    public GameObject ChimneyIcon;
    public GameObject DoorIcon;
    public GameObject WindowIcon;
    public GameObject MailboxIcon;
    public GameObject MailIcon;
    public GameObject PackageIcon;


	// Use this for initialization
	void Start () {
        CurrentMission = 0;
        LastShown = 0;
        // Min = 1; Max = 77
        int DeliveryCount = 10; // Nombre de livraisons

        Missions = new int[DeliveryCount * 3, 6];
        int CurrentAddress = 0;
        int CurrentLine = 0;

        MISSION_ITEMS[] Targets = new MISSION_ITEMS[] { MISSION_ITEMS.CHIMNEY, MISSION_ITEMS.DOOR, MISSION_ITEMS.MAILBOX, MISSION_ITEMS.WINDOW };
        MISSION_ITEMS[] Types = new MISSION_ITEMS[] { MISSION_ITEMS.MAIL, MISSION_ITEMS.PACKAGE };
        int TargetsCount = 0; // Nombre de cibles différentes par livraison entre (1 et 3)
        int PackagesCount = 0; // Nombre de lettres/colis à livrer pour une cible

        int[] Content = new int[4];


        while(DeliveryCount > 0)
        {
            CurrentAddress += UnityEngine.Random.Range(1, 8);
            if(CurrentAddress > 77) {
                DeliveryCount = 0;
                break;
            }
            if(CurrentAddress == 8 || CurrentAddress == 22 || CurrentAddress == 30 || CurrentAddress == 32 || CurrentAddress == 34 || CurrentAddress == 56 || CurrentAddress == 58) // Il n'y a pas de maison numéro 8, ni numéro 22...
            {
                CurrentAddress++;
            }
            TargetsCount = UnityEngine.Random.Range(1, 4);
            while(TargetsCount > 0)
            {
                int Target = (int)Targets[UnityEngine.Random.Range(0, Targets.Length)];
                PackagesCount = UnityEngine.Random.Range(1, 5);
                for(int i = 0; i < 4; i++)
                {
                    if(i < PackagesCount)
                    {
                        Content[i] = (int)Types[UnityEngine.Random.Range(0, Types.Length)];
                    }
                    else
                    {
                        Content[i] = -1;
                    }
                }
                Missions[CurrentLine, 0] = CurrentAddress;
                Missions[CurrentLine, 1] = (int)Target;
                Missions[CurrentLine, 2] = Content[0];
                Missions[CurrentLine, 3] = Content[1];
                Missions[CurrentLine, 4] = Content[2];
                Missions[CurrentLine, 5] = Content[3];
                CurrentLine++;
                TargetsCount--;
            }
            DeliveryCount--;
        }

        // {114, (int)MISSION_ITEMS.CHIMNEY, (int)MISSION_ITEMS.PACKAGE,(int)MISSION_ITEMS.MAIL, (int)MISSION_ITEMS.MAIL,-1 },
        // {114, (int)MISSION_ITEMS.DOOR, (int)MISSION_ITEMS.MAIL, (int)MISSION_ITEMS.MAIL,-1 ,-1},
        // {114, (int)MISSION_ITEMS.WINDOW, (int)MISSION_ITEMS.PACKAGE, (int)MISSION_ITEMS.PACKAGE,(int)MISSION_ITEMS.MAIL ,(int)MISSION_ITEMS.PACKAGE},
        // {210, (int) MISSION_ITEMS.DOOR, (int)MISSION_ITEMS.PACKAGE, (int)MISSION_ITEMS.PACKAGE, -1,-1},
        // {216, (int)MISSION_ITEMS.MAILBOX, (int)MISSION_ITEMS.PACKAGE, (int)MISSION_ITEMS.PACKAGE, (int)MISSION_ITEMS.MAIL,-1 }
        DisplayMission(Missions[CurrentMission, 0], CurrentMission);
    }
	
	// Update is called once per frame
	void Update () {
		
	}

    public bool Accomplish(int adresse, MISSION_ITEMS target, MISSION_ITEMS type)
    {
        Debug.Log("Je teste " + adresse);
        if(adresse == Missions[CurrentMission, 0])
        {
            for (int i = 0; i < columnCount; i++)
            {
                if (Missions[CurrentMission + i, 1] == (int)target)
                {
                    for (int j = 2; j <= 5; j++)
                    {
                        if (Missions[CurrentMission + i, j] == (int)type)
                        {
                            Missions[CurrentMission + i, j] = -1;
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    public bool CurrentMissionIsCompleted()
    {
        for (int i = 0; i < columnCount; i++)
        {
            for (int j = 2; j <= 5; j++)
            {
                if (Missions[CurrentMission + i, j] != -1)
                {
                    return false; // La mission n'est pas terminée
                }
            }
        }
        return true;
    }

    public void NextMision()
    {
        Debug.Log("CurrentMission ++");
        CurrentMission+=columnCount;
        UpdateView();
    }

    public void UpdateView()
    {
        for(int i = 0; i < 3; i++)
        {
            for (int j = 0; j < transform.GetChild(1).GetChild(i).transform.childCount; j++)
            {
                Destroy(transform.GetChild(1).GetChild(i).transform.GetChild(j).gameObject);
            }
        }
        
        DisplayMission(Missions[CurrentMission, 0], CurrentMission);
    }

    void DisplayMission(int mission, int count)
    {
        columnCount = 0;
        transform.GetChild(0).gameObject.GetComponent<Text>().text = "ADRESSE : N°"+ Missions[count, 0];
        for (int i = 0; i < Missions.GetLength(0); i++)
        {
            if (Missions[i, 0] == mission)
                {

               
                    /*
                    Debug.Log("Display please mission = " + mission + " count = " + count + " mission i 0 " + Missions[i, 0]);
                    if (Missions[i, 0] != mission)
                    {
                        Debug.Log("Je sors à " + Missions[i, 0] + "!=" + mission);

                        return;
                    }
                    else
                    {*/
                        GameObject target = Instantiate(CurrentTarget(Missions[i, 1]));
                    target.transform.SetParent(transform.GetChild(1).GetChild(columnCount));
                    target.GetComponent<RectTransform>().localPosition = new Vector3(0f, 0f, 0f);
                    target.GetComponent<RectTransform>().localScale = new Vector3(1, 1, 1);
                    target.GetComponent<RectTransform>().localRotation = new Quaternion(0, 0, 0, 0);
                    for (int j = 2; j <= 5; j++)
                    {
                        Debug.Log(Missions[i,j]);
                        if (Missions[i, j] != -1)
                        {
                            if (Missions[i, j] == (int)MISSION_ITEMS.MAIL)
                            {
                                GameObject mail = Instantiate(MailIcon);
                                mail.transform.SetParent(target.transform.parent);
                                mail.GetComponent<RectTransform>().localPosition = new Vector3(0f, 0f, 0f);
                                mail.GetComponent<RectTransform>().localScale = new Vector3(1, 1, 1);
                                mail.GetComponent<RectTransform>().localRotation = new Quaternion(0, 0, 0, 0);
                                mail.transform.SetAsLastSibling();
                            }
                            else
                            {
                                GameObject package = Instantiate(PackageIcon);
                                package.transform.SetParent(target.transform.parent);
                                package.GetComponent<RectTransform>().localPosition = new Vector3(0f, 0f, 0f);
                                package.GetComponent<RectTransform>().localScale = new Vector3(1, 1, 1);
                                package.GetComponent<RectTransform>().localRotation = new Quaternion(0, 0, 0, 0);
                                package.transform.SetAsLastSibling();
                            }
                        }
                    }
                    columnCount++;
                    LastShown++;
                //}
                if (columnCount == 3) return;
            }
        }
    }

    GameObject CurrentTarget(int index)
    {
        switch (index)
        {
            case (int)MISSION_ITEMS.CHIMNEY:  return ChimneyIcon;
            case (int)MISSION_ITEMS.DOOR: return DoorIcon;
            case (int)MISSION_ITEMS.MAILBOX: return MailboxIcon;
            case (int)MISSION_ITEMS.WINDOW: return WindowIcon;
            default: return ChimneyIcon;
        }
    }
    


}
