﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Projectile : MonoBehaviour
{

    public string DisplayName = "Default Name";
    public Sprite Icon;
    public float TimeToLive = 10;
    public bool gravityBeforeCollision;
    private bool Delivered = false;

    public bool IsDelivered()
    {
        return this.Delivered;
    }

    public void SetDelivered(bool b)
    {
        this.Delivered = b;
    }

    // Use this for initialization
    void Start()
    {
        if (gravityBeforeCollision == false)
        {
            GetComponent<Rigidbody>().useGravity = false;
        }
        else
        {
            GetComponent<Rigidbody>().useGravity = true;
        }
    }

    // Update is called once per frame
    void Update()
    {
        TimeToLive -= Time.deltaTime;
        if (TimeToLive < 0)
        {
            Destroy(this.gameObject);
        }
    }

    void OnCollisionEnter(Collision collision)
    {
        GetComponent<Rigidbody>().useGravity = true;
    }
}
