﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class TimerScript : MonoBehaviour {
    public float startTimer;
    public GameObject GameOverPrefab;

    public static float remainingTime;
    public static float totalTime;
    private bool gameOverDisplayed = false;


	// Use this for initialization
	void Start () {
        remainingTime = startTimer;
        totalTime = remainingTime;
	}
	
	// Update is called once per frame
	void Update () {
        if(remainingTime > 0)
        {
            transform.GetChild(0).GetComponent<Text>().text = DisplayTime(remainingTime);
            remainingTime -= Time.deltaTime / 2;
            totalTime += Time.deltaTime / 2;
        } else if (remainingTime != -100)
        {
            TimesUp();
        }

    }

    public void GainTime(float seconds)
    {
        remainingTime += seconds;
        totalTime += seconds;
    }

    public void LooseTime(float seconds)
    {
        remainingTime -= seconds;
        totalTime -= seconds;
    }

    void TimesUp()
    {
        if (GameOverPrefab != null && !gameOverDisplayed)
        {
            Debug.Log("Time's Up!");
            gameOverDisplayed = true;
            Instantiate(GameOverPrefab, new Vector3 (0f, 0f, 0f), Quaternion.identity);
        }
    }

    string DisplayTime(float remaining)
    {
        int minutes = Mathf.FloorToInt(remaining / 60F);
        int seconds = Mathf.FloorToInt(remaining - minutes * 60);
        
        string niceTime = string.Format("{0:00}:{1:00}", minutes, seconds);

        return niceTime;
    }
}
