﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class Turret : MonoBehaviour {

    public Projectile Letter;
    public Projectile Package;
    public List<Projectile> Clip;
    public Transform Spawnpoint;
    public float PowerLetter;
    public float PowerPackage;
    public ClipPreview ClipPreview;
    public PickupPreview PickupPreview;
    public Image Cursor;
    bool Clicked;
    public int PackagesThrowsCount = 0;
    public int LettersThrowsCount = 0;
    public GameObject LetterSound;
    public GameObject PackageSound;

	// Use this for initialization
	void Start () {
        Clip = new List<Projectile>();
        Clicked = false;
    }
	
	// Update is called once per frame
	void Update () {
	    if(Input.GetKeyUp(KeyCode.L))
        {
            AddLetter();
        }

        if(Input.GetKeyUp(KeyCode.P))
        {
            AddPackage();
        }

        RaycastHit hit;
        AmmoBox AmmoBox = null;
        Vector3 fwd = Spawnpoint.transform.forward;
        if (Physics.Raycast(Spawnpoint.transform.position, fwd, out hit))
        {
            if (hit.transform.gameObject.CompareTag("AmmoBox"))
            {
                if (PickupPreview != null)
                {
                    AmmoBox = hit.transform.GetComponent<AmmoBox>();
                    this.PickupPreview.Draw(AmmoBox.Projectile);
                }
            }
        }

        Cursor.enabled = !AmmoBox;

        if(!Clicked)
        {
            if(Input.GetButtonDown("Fire1"))
            {
                Clicked = true;
                if(AmmoBox)
                {
                    Clip.Add(AmmoBox.Projectile);
                    UpdateClipPreview();
                }
                else
                {
                    Fire();
                }
            }
        }

        if (Input.GetButtonUp("Fire1"))
        {
            Clicked = false;
        }
    }


    void AddPackage()
    {
        if (Package != null)
        {
            Clip.Add(Package);
            UpdateClipPreview();
        }
        else
        {
            Debug.LogError("Prefab : \"Package\" not found.");
        }
    }

    void AddLetter()
    {
        if (Letter != null)
        {
            Clip.Add(Letter);
            UpdateClipPreview();
        }
        else
        {
            Debug.LogError("Prefab : \"Letter\" not found.");
        }
    }

    void Fire()
    {
        if (Clip.Count > 0)
        {
            Debug.Log("Fire");
            GameObject currentAmmo = Clip[0].gameObject;
            Vector3 vel = Spawnpoint.transform.forward;
            if(currentAmmo.GetComponent<Projectile>().DisplayName == "Colis")
            {
                PackagesThrowsCount++;
                vel *= PowerPackage;
                Instantiate(PackageSound, Spawnpoint.position, Spawnpoint.rotation);
            }
            else
            {
                LettersThrowsCount++;
                vel *= PowerLetter;
                Instantiate(LetterSound, Spawnpoint.position, Spawnpoint.rotation);
            }
            Clip.RemoveRange(0, 1);
            Rigidbody clone = (Rigidbody)Instantiate(currentAmmo.GetComponent<Rigidbody>(), Spawnpoint.position, Spawnpoint.rotation);
            clone.GetComponent<Rigidbody>().AddForce(vel);
            UpdateClipPreview();
        }
        else
        {
            Debug.Log("No ammo");
        }
    }

    void UpdateClipPreview()
    {
        if (ClipPreview != null)
        {
            ClipPreview.Draw(this.Clip);
        }
    }
}
